﻿
' TODO
' ---------------------------------------------------------- important

' ---------------------------------------------------------- secondary
' PlaySound
' SendMail 
' (example: when radioactivity is more than some limit)
' ---------------------------------------------------------- to be tested
' 
' ---------------------------------------------------------- done
' Test WAIT with EvalDouble


Imports System.Collections.Generic

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        RTB.Editing = True
        If FullScreen Then RTB.Editing = False
        RTB_Init()
        Load_INI()
        Load_Program()
        ApplyEditorProps()
        UI_Timer.Interval = 15
        UI_Timer.Start()
        ExecutionThread_Start()
        ShedulerMaxPrecision()
        EventsAreEnabled = True
        SetViewMode()
        Me.BackColor = Color_Form
        GroupBox1.BackColor = Color_Panels
        GroupBox2.BackColor = Color_Panels
        PreparePanelsForProgram()
        ShowInTaskbar = False
        ShowInTaskbar = True
        If RTB.Editing Then
            CheckBox_EditProgram.Checked = True
            StartRtbEditing()
        Else
            StartRtbExecution()
        End If
        Me.Hide()
        Me.Show()
        WMP_Init()
        RTB.Focus()
        RTB.ShowSuggestions(StatusLabel1, Label_Lines)
        Refresh()
        Me.Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        WMP.URL = Nothing
        SaveProgram_IfChanged()
        Save_INI()
        ExecutionThread_Stop()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    ' =============================================================================================
    '  MenuStrip, ToolStrip and RichTextBox accepting the first click
    '  If the form is not focused and receives a WM_PARENTNOTIFY (528) message
    '  then the form is activated before to exec the message
    ' =============================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub

    ' -----------------------------------------------------------------------------------------------------
    '  CONTEXTUAL MENU - EDITOR
    ' -----------------------------------------------------------------------------------------------------
    Private Sub CTX_Edit_Cut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Cut.Click
        RTB.ExecCut()
    End Sub
    Private Sub CTX_Edit_Copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Copy.Click
        RTB.ExecCopy()
    End Sub
    Private Sub CTX_Edit_Paste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Paste.Click
        RTB.ExecPaste()
    End Sub
    Private Sub CTX_Edit_Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Delete.Click
        RTB.ExecDelete()
    End Sub
    Private Sub CTX_Edit_SelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_SelectAll.Click
        RTB.SelectAll()
    End Sub
    Private Sub CTX_Edit_Comment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Comment.Click
        RTB.CommentSelectedLines(True)
    End Sub
    Private Sub CTX_Edit_Uncomment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Uncomment.Click
        RTB.CommentSelectedLines(False)
    End Sub
    Private Sub CTX_Edit_Indent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Indent.Click
        RTB.IndentSelectedLines(+1)
    End Sub
    Private Sub CTX_Edit_Unindent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Unindent.Click
        RTB.IndentSelectedLines(-1)
    End Sub
    Private Sub CTX_Edit_Find_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Find.Click
        Editor_Find()
    End Sub
    Private Sub CTX_Edit_Replace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTX_Edit_Replace.Click
        Editor_FindReplace()
    End Sub

    ' ===============================================================================================================
    '  FIND - REPLACE and Options
    ' ===============================================================================================================
    Friend Sub Editor_Find()
        With Form_Replace
            .TopMost = True
            .DialogType = Form_Replace.DialogTypeValue.Find
            .OwnerCodeBox = RTB
            .Show()
            .txtFind.Focus()
        End With
    End Sub
    Friend Sub Editor_FindReplace()
        With Form_Replace
            .TopMost = True
            .DialogType = Form_Replace.DialogTypeValue.Replace
            .OwnerCodeBox = RTB
            .Show()
            .txtFind.Focus()
        End With
    End Sub

    ' =============================================================================================
    '  APPLICATION BUTTONS
    ' ============================================================================================= 
    Private Sub CheckBox_Undo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox_Undo.Click
        RTB.ExecUndo()
        RTB.Focus()
        CheckBox_Undo.Checked = False
    End Sub
    Private Sub CheckBox_Redo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox_Redo.Click
        RTB.ExecRedo()
        RTB.Focus()
        CheckBox_Redo.Checked = False
    End Sub
    Private Sub CheckBox_Load_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox_Load.Click
        LoadProgramDialog()
        RTB.Focus()
        CheckBox_Load.Checked = False
    End Sub
    Private Sub CheckBox_Save_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox_Save.Click
        SaveProgramDialog()
        RTB.Focus()
        CheckBox_Save.Checked = False
    End Sub
    Private Sub CheckBox_EditProgram_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox_EditProgram.Click
        If CheckBox_EditProgram.Checked Then
            StartRtbEditing()
        Else
            StartRtbExecution()
        End If
    End Sub
    Private Sub CheckBox_FullScreen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_FullScreen.Click
        StartAndCloseFullScreen()
        CheckBox_FullScreen.Checked = False
    End Sub
    Private Sub CheckBox_CloseAll_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_CloseAll.Click
        CloseAllThereminoApps()
        EventsAreEnabled = False
        ExecutionThread_Stop()
        Save_INI()
        Me.Close()
    End Sub
    Private Sub CheckBox_ColorLines_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_ColorLines.CheckedChanged
        If Not EventsAreEnabled Then Return
        CheckBox_ColorLines.Refresh()
        RTB.ColorVisibleLines()
        'RTB.ColorAllLines()
        EventsAreEnabled = False
        CheckBox_ColorLines.Checked = False
        EventsAreEnabled = True
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If My.Computer.Keyboard.CtrlKeyDown Then
            e.SuppressKeyPress = True
            e.Handled = True
            Select Case e.KeyCode
                Case Keys.X : RTB.ExecCut()
                Case Keys.C : RTB.ExecCopy()
                Case Keys.V : RTB.ExecPaste()
                Case Keys.Z : RTB.ExecUndo()
                Case Keys.Y : RTB.ExecRedo()
                Case Else
                    e.Handled = False
                    e.SuppressKeyPress = False
            End Select
        End If
        If Not RTB.Editing Then
            e.SuppressKeyPress = True
            e.Handled = True
            If Not ExecutingKeyPress Then
                ExecutingKeyPress = True
                ExecKeysEvent(e.KeyCode)
            End If
        End If
    End Sub
    Private ExecutingKeyPress As Boolean = False
    Private Sub Form1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        RTB.Focus()
        ExecutingKeyPress = False
    End Sub

    ' =============================================================================================
    '  FULL SCREEN
    ' ============================================================================================= 
    Friend WindowRectangle As Rectangle
    Friend FullScreen As Boolean = False
    Friend Password As String = ""
    Private Sub StartAndCloseFullScreen()
        If Not FullScreen Then
            Password = InputBox("This password will be requested to exit full screen.", , Password).Trim.ToLower
            If Password <> "" Then
                StartRtbExecution()
                Me.Opacity = 0
                WindowRectangle = Me.Bounds
                FullScreen = True
                SetViewMode()
                Me.Opacity = 100
                Save_INI()
            End If
        Else
            Me.TopMost = False
            If Password = "" OrElse InputBox("Password?").Trim.ToLower = Password.Trim.ToLower Then
                Me.Opacity = 0
                FullScreen = False
                SetViewMode()
                Me.WindowState = FormWindowState.Normal
                Me.Bounds = WindowRectangle
                Me.Opacity = 100
                Save_INI()
            Else
                Me.TopMost = True
            End If
        End If
    End Sub
    Private Sub SetViewMode()
        If FullScreen Then
            CheckBox_FullScreen.Text = "EXIT FULL SCREEN"
            CheckBox_EditProgram.Visible = False
            CheckBox_Undo.Visible = False
            CheckBox_Redo.Visible = False
            CheckBox_Load.Visible = False
            CheckBox_Save.Visible = False
            Panel_EditCommands.Visible = False
            RTB.Height = GroupBox2.Height - RTB.Top - 2
            Me.ShowInTaskbar = False
            Me.Text = ""
            Me.Location = New Point(0, 0)
            Me.FormBorderStyle = Windows.Forms.FormBorderStyle.None
            Me.ControlBox = False
            Me.WindowState = FormWindowState.Maximized
            Me.TopMost = True
            Me.Hide()
            Me.Show()
            Me.Refresh()
        Else
            CheckBox_FullScreen.Text = "FULL SCREEN"
            CheckBox_EditProgram.Visible = True
            CheckBox_Undo.Visible = True
            CheckBox_Redo.Visible = True
            CheckBox_Load.Visible = True
            CheckBox_Save.Visible = True
            Panel_EditCommands.Visible = RTB.Visible
            RTB.Height = GroupBox2.Height - RTB.Top - 28
            ShowWindowTitle()
            Me.ShowInTaskbar = True
            Me.FormBorderStyle = Windows.Forms.FormBorderStyle.Sizable
            Me.ControlBox = True
            Me.TopMost = False
        End If
    End Sub

    Friend Sub ShowWindowTitle()
        Text = AppTitleAndVersion() + "  -  Program :  " + IO.Path.GetFileName(ProgramFile_PathAndName)
    End Sub


    ' =============================================================================================
    '  RICH TEXT BOX EDITOR
    ' =============================================================================================
    Private Color_Form As Color = Color.FromArgb(220, 220, 240)
    Private Color_Panels As Color = Color.FromArgb(240, 240, 240)
    Private Color_PanelEditing As Color = Color.FromArgb(240, 220, 180)
    Private Color_BackEditing As Color = Color.FromArgb(255, 250, 240)
    Private Color_BackRunning As Color = Color.FromArgb(240, 240, 240)

    Private Sub RTB_Init()
        With RTB
            .AcceptsTab = True
            .DetectUrls = False
            .WordWrap = False
            .HideSelection = False
            .Font = New Font("Courier New", 12, FontStyle.Regular)
            .AutoWordSelection = True
            .AutoWordSelection = False
        End With
        'RTB_SetTabPositions(4)
    End Sub
    ' -------------------------------------------------------
    '  Trying to set 4 spaces for each tab but not working 
    ' -------------------------------------------------------
    'Private Sub RTB_SetTabPositions(ByVal tabsize As Int32)
    '    Dim ar(31) As Int32
    '    For i As Int32 = 0 To 31
    '        ar(i) = CInt(i * TabSize * RTB.Font.Height / 2)
    '    Next
    '    RTB.SelectionTabs = ar
    'End Sub

    Private Sub CheckBox_AutoComplete_CheckStateChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles _
                                                                           CheckBox_AutoComplete.CheckStateChanged
        If Not EventsAreEnabled Then Return
        ApplyEditorProps()
        RTB.Focus()
        RTB.ShowSuggestions(StatusLabel1, Label_Lines)
    End Sub
    Private Sub TrackBars_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles _
                                                                                    TrackBar_Speed.MouseLeave, _
                                                                                    TrackBar_Zoom.MouseLeave
        RTB.Focus()
    End Sub
    Private Sub TrackBars_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
                                                                                    TrackBar_Speed.Scroll, _
                                                                                    TrackBar_Zoom.Scroll
        If Not EventsAreEnabled Then Return
        ApplyEditorProps()
    End Sub
    Friend Sub ApplyEditorProps(Optional ByVal ForceNewZoom As Boolean = False)
        If ForceNewZoom Then RTB.ZoomFactor = 0.1
        RTB.ZoomFactor = TrackBar_Zoom.Value / 10.0F
        SetExecutionDelayParams(TrackBar_Speed.Value)
        ShowExecutionDelayText(TrackBar_Speed.Value)
        Select Case CheckBox_AutoComplete.CheckState
            Case CheckState.Checked
                RTB.AutoSelect = True
                RTB.AutoComplete = False
                CheckBox_AutoComplete.Text = "Auto select"
            Case CheckState.Indeterminate
                RTB.AutoSelect = True
                RTB.AutoComplete = True
                CheckBox_AutoComplete.Text = "Auto complete"
            Case CheckState.Unchecked
                RTB.AutoSelect = False
                RTB.AutoComplete = False
                CheckBox_AutoComplete.Text = "Auto disabled"
        End Select
    End Sub

    Private Sub StartRtbEditing()
        PreparePanelsForProgram()
        ExecutionThread_Stop()
        DisableProgrammableButtons()
        UncheckProgrammableButtons()
        CheckBox_Undo.Enabled = True
        CheckBox_Redo.Enabled = True
        CheckBox_Load.Enabled = True
        CheckBox_Save.Enabled = True
        CheckBox_EditProgram.Text = "RUN"
        CheckBox_AutoComplete.Visible = True
        Label_Lines.Visible = True
        RTB.ScrollBars = RichTextBoxScrollBars.Both
        RTB.ReadOnly = False
        RTB.SelectLine(-1)
        RTB.Focus()
        GroupBox2.BackColor = Color_PanelEditing
        RTB.BackColor = Color_BackEditing
        StatusStrip1.BackColor = Color.AliceBlue
        StatusLabel1.BackColor = Color.AliceBlue
        StatusLabel1.Text = ""
        RTB.Editing = True
        RTB.SelectionStart = 1
        RTB.SelectionStart = 0
        WMP.Visible = False
        WMP.URL = Nothing
        SetDefaultButtonNames()
    End Sub
    Private Sub StartRtbExecution()
        ExecutionThread_Stop()
        RTB.Editing = False
        SaveProgram_IfChanged()
        RTBLines = RTB.Lines
        ClearKeyEvents()
        ReturnStack.Clear()
        GotoLine = 0
        SetExecutionDelayParams(TrackBar_Speed.Value)
        ExecutionThread_Start()
        EnableProgrammableButtons()
        UncheckProgrammableButtons()
        CheckBox_Undo.Enabled = False
        CheckBox_Redo.Enabled = False
        CheckBox_Load.Enabled = False
        CheckBox_Save.Enabled = False
        CheckBox_EditProgram.Text = "EDIT"
        CheckBox_EditProgram.Checked = False
        CheckBox_AutoComplete.Visible = False
        Label_Lines.Visible = False
        'RTB.ScrollBars = RichTextBoxScrollBars.None
        RTB.ReadOnly = True
        LineInExecution = -1
        GroupBox2.BackColor = GroupBox1.BackColor
        RTB.BackColor = Color_BackRunning
        StatusStrip1.BackColor = Color.AliceBlue
        StatusLabel1.BackColor = Color.AliceBlue
        StatusLabel1.Text = ""
    End Sub

    ' =============================================================================================
    '  PROGRAMMABLE BUTTONS
    ' =============================================================================================
    Private Sub SetDefaultButtonNames()
        For i As Int32 = 1 To 5
            SetButton(i, "Button " + i.ToString)
        Next
    End Sub
    Private Sub DisableProgrammableButtons()
        Button_1.Enabled = False
        Button_2.Enabled = False
        Button_3.Enabled = False
        Button_4.Enabled = False
        Button_5.Enabled = False
    End Sub
    Private Sub EnableProgrammableButtons()
        Button_1.Enabled = True
        Button_2.Enabled = True
        Button_3.Enabled = True
        Button_4.Enabled = True
        Button_5.Enabled = True
    End Sub
    Private Sub UncheckProgrammableButtons()
        Button_1.Checked = False
        Button_2.Checked = False
        Button_3.Checked = False
        Button_4.Checked = False
        Button_5.Checked = False
    End Sub
    Private Sub Buttons_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button_1.Click, _
                                                                                           Button_2.Click, _
                                                                                           Button_3.Click, _
                                                                                           Button_4.Click, _
                                                                                           Button_5.Click
        ExecButton(CType(sender, CheckBox))
    End Sub

    Private ButtonSlots() As Int32 = {-1, -1, -1, -1, -1}
    Private ButtonSlotsOldValues(4) As Single
    Private Sub ExecButtonsFromSlots()
        For i As Int32 = 0 To 4
            If ButtonSlots(i) >= 0 Then
                Dim NewValue As Single = Slots.ReadSlot_NoNan(ButtonSlots(i))
                If NewValue > 500 And ButtonSlotsOldValues(i) <= 500 Then
                    Dim button As CheckBox
                    Select Case i
                        Case 0 : button = Button_1
                        Case 1 : button = Button_2
                        Case 2 : button = Button_3
                        Case 3 : button = Button_4
                        Case 4 : button = Button_5
                        Case Else : button = Button_1
                    End Select
                    If button.Enabled Then
                        button.Checked = True
                        ExecButton(button)
                    End If
                End If
                ButtonSlotsOldValues(i) = NewValue
            End If
        Next
    End Sub
    Private Sub ExecButton(ByVal button As CheckBox)
        Dim line As Int32 = FindLabel(button.Text)
        If line >= 0 Then
            ExecutionThread_Stop()
            If ExistsReturn() Then
                ReturnStack.Push(LineInExecution)
            End If
            GotoLine = line
            ExecutionThread_Start()
            button.Checked = False
        End If
    End Sub
    Private Function ExistsReturn() As Boolean
        Dim line As String
        For i As Int32 = 0 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("return") Then
                Return True
            End If
        Next
        Return False
    End Function
    Private Function FindLabel(ByVal TextToFind As String) As Int32
        ' ----------------------------------------------------------------------- compare with label text
        Dim TextToFind1 As String = " " + TextToFind.ToLower
        Dim TextToFind2 As String = " """ + TextToFind.ToLower + """"
        Dim line As String
        For i As Int32 = 0 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("label") Then
                RTB.RemoveComments(line)
                If line.EndsWith(TextToFind1) Or line.EndsWith(TextToFind2) Then
                    Return i
                End If
            End If
        Next
        ' ----------------------------------------------------------------------- if not found then extract first word
        TextToFind1 = " " & RTB.ExtractFirstWord(TextToFind).ToLower
        For i As Int32 = 0 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line.StartsWith("label") Then
                RTB.RemoveComments(line)
                If line.EndsWith(TextToFind1) Then
                    Return i
                End If
            End If
        Next
        Return -1
    End Function

    ' =============================================================================================
    '  WINDOWS SCHEDULER PRECISION
    ' ============================================================================================= 
    Private Declare Function timeBeginPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    Private Declare Function timeEndPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    Private Sub ShedulerMaxPrecision()
        If OperatingSystemIsWindows Then
            timeBeginPeriod(1)
        End If
    End Sub
    Private Sub ShedulerDefaultPrecision()
        If OperatingSystemIsWindows Then
            timeEndPeriod(1)
        End If
    End Sub

    ' =============================================================================================
    '   USER INTERFACE EXECUTION
    ' =============================================================================================
    Private Sub UI_Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UI_Timer.Tick
        If RTB.Editing Then Return
        ExecButtonsFromSlots()
        If LineInExecution >= 0 Then
            RTB.Select(RTB.GetFirstCharIndexFromLine(LineInExecution), 1)
            'RTB.SelectLine(LineInExecution)
        End If
    End Sub

    ' =============================================================================================
    '   EXECUTION THREAD
    ' =============================================================================================
    Private ExecutionThread As Thread
    Sub ExecutionThread_Start()
        ExecutionThread = New Thread(AddressOf MainExecutionThread)
        ExecutionThread.Start()
        ExecutionThread.Priority = System.Threading.ThreadPriority.AboveNormal
    End Sub
    Sub ExecutionThread_Stop()
        If ExecutionThread Is Nothing Then Return
        ExecutionThread.Abort()
        ExecutionThread.Join()
        ExecutionThread = Nothing
    End Sub
    Sub MainExecutionThread()
        Do
            RTB_Exec()
        Loop
    End Sub

    ' =============================================================================================
    '   EXECUTION HELPING FUNCTIONS - WITH Invoke from Worker-Thread to UserInterface-Thread
    ' =============================================================================================
    Private Delegate Sub SetButton_Delegate(ByVal nbutton As Int32, ByVal text As String)
    Private Sub SetButton(ByVal nbutton As Int32, ByVal text As String)
        If InvokeRequired Then
            BeginInvoke(New SetButton_Delegate(AddressOf SetButton), nbutton, text)
        Else
            Dim b As CheckBox = Button_1
            Select Case nbutton
                Case 1 : b = Button_1
                Case 2 : b = Button_2
                Case 3 : b = Button_3
                Case 4 : b = Button_4
                Case 5 : b = Button_5
            End Select
            If text = Nothing Then
                b.Visible = False
                Return
            Else
                b.Visible = True
            End If
            Select Case text.ToLower
                Case "enabled"
                    b.Enabled = True
                Case "disabled"
                    b.Enabled = False
                Case Else
                    Dim pixels As Size = TextRenderer.MeasureText(text, b.Font)
                    If pixels.Width < b.Width - 10 Then
                        b.Font = New Font(b.Font.FontFamily, 14)
                    Else
                        b.Font = New Font(b.Font.FontFamily, 10)
                    End If
                    b.Text = text
            End Select
        End If
    End Sub

    Private Delegate Sub SetButtonSlot_Delegate(ByVal nbutton As Int32, ByVal slot As Int32)
    Private Sub SetButtonSlot(ByVal nbutton As Int32, ByVal slot As Int32)
        If InvokeRequired Then
            BeginInvoke(New SetButtonSlot_Delegate(AddressOf SetButtonSlot), nbutton, slot)
        Else
            If nbutton > ButtonSlots.Length Then Return
            ButtonSlots(nbutton - 1) = slot
        End If
    End Sub

    Private Delegate Sub UncheckButton_Delegate(ByVal button As CheckBox)
    Private Sub UncheckButton(ByVal button As CheckBox)
        If InvokeRequired Then
            BeginInvoke(New UncheckButton_Delegate(AddressOf UncheckButton), button)
        Else
            button.Checked = False
        End If
    End Sub

    Private Delegate Sub Print_Message_Delegate(ByVal message As String)
    Private Sub Print_Message(ByVal message As String)
        If InvokeRequired Then
            BeginInvoke(New Print_Message_Delegate(AddressOf Print_Message), message)
        Else
            StatusLabel1.Text = message
            StatusLabel1.Invalidate()
        End If
    End Sub

    Private Delegate Sub SetNewSpeed_Delegate(ByVal speed As Double)
    Private Sub SetNewSpeed(ByVal speed As Double)
        If InvokeRequired Then
            BeginInvoke(New SetNewSpeed_Delegate(AddressOf SetNewSpeed), speed)
        Else
            SetExecutionDelayParams(CInt(speed))
        End If
    End Sub


    Private WithEvents WB As WebBrowser = New WebBrowser
    Private Delegate Sub Load_Media_Delegate(ByVal filename As String)
    Private Sub Load_Media(ByVal filename As String)
        If InvokeRequired Then
            ' ------------------------------------ wait the command execution with "Invoke" (not "BeginInvoke")
            Invoke(New Load_Media_Delegate(AddressOf Load_Media), filename)
        Else
            Select Case filename.ToLower
                Case "stop" : WMP.URL = ""
                Case "hide" : PreparePanelsForProgram()
                Case Else
                    If filename.StartsWith("http", StringComparison.InvariantCultureIgnoreCase) Then
                        PreparePanelsForWeb()
                        WB.Navigate(New Uri(filename))
                    Else
                        Dim fullPath As String
                        Select Case Strings.Right(filename, 4).ToLower
                            Case ".txt"
                                fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Programs\" & filename)
                                If My.Computer.FileSystem.FileExists(fullPath) Then
                                    ExecutionThread_Stop()
                                    Load_Program(fullPath)
                                    RTBLines = RTB.Lines
                                    GotoLine = 0
                                    ExecutionThread_Start()
                                End If
                                ExecutionDelay_Variable()
                            Case ".jpg", ".bmp"
                                GroupBox2.Text = filename
                                fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & filename)
                                If My.Computer.FileSystem.FileExists(fullPath) Then
                                    PictureBox1.Image = Image.FromFile(fullPath)
                                    PreparePanelsForImages()
                                    GroupBox2.Text = filename
                                End If
                            Case ".avi", ".wmv", ".mpg", ".mp4", ".mov", ".gif"
                                GroupBox2.Text = "Loading """ + filename + """   >>> PLEASE WAIT SOME SECONDS <<<"
                                fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & filename)
                                If My.Computer.FileSystem.FileExists(fullPath) Then
                                    WMP.URL = fullPath
                                    WMP_WaitReady()
                                    PreparePanelsForVideo()
                                    GroupBox2.Text = filename
                                End If
                            Case ".mp3", ".wav"
                                GroupBox2.Text = filename
                                fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & filename)
                                If My.Computer.FileSystem.FileExists(fullPath) Then
                                    WMP.Hide()
                                    WMP.URL = fullPath
                                    WMP_WaitReady()
                                    GroupBox2.Text = filename
                                End If
                        End Select
                    End If
            End Select
        End If
    End Sub

    Private Sub WMP_WaitReady()
        Do
            Application.DoEvents()
        Loop Until WMP.playState <> WMPLib.WMPPlayState.wmppsTransitioning
    End Sub
    Private Sub WMP_Init()
        WMP.Dock = DockStyle.Fill
        WMP.stretchToFit = True
        WMP.enableContextMenu = False
        WMP.uiMode = "none"
        WMP.Visible = False
    End Sub
    Private Sub PreparePanelsForImages()
        GroupBox2.Text = ""
        GroupBox2.BackgroundImageLayout = ImageLayout.Stretch
        GroupBox2.BackColor = Color.White
        WebBrowserStop()
        WMP.Visible = False
        RTB.Visible = False
        PictureBox1.Left = 2
        PictureBox1.Top = 16
        If PictureBox1.Size.Width < GroupBox2.ClientSize.Width - 20 Then
            PictureBox1.Width = GroupBox2.ClientSize.Width - 4
            PictureBox1.Height = GroupBox2.ClientSize.Height - 16
        End If
        PictureBox1.Visible = True
        Panel_EditCommands.Visible = False
    End Sub
    Private Sub PreparePanelsForVideo()
        GroupBox2.Text = ""
        GroupBox2.BackgroundImage = Nothing
        GroupBox2.BackColor = Color_Panels
        RTB.Visible = False
        PictureBox1.Visible = False
        WebBrowserStop()
        WMP.stretchToFit = True
        WMP.Left = 0
        WMP.Top = 0
        If WMP.Size.Width < GroupBox2.ClientSize.Width - 20 Then
            WMP.Size = GroupBox2.ClientSize
        End If
        WMP.Visible = True
        Panel_EditCommands.Visible = False
    End Sub
    Private Sub PreparePanelsForProgram()
        GroupBox2.Text = "Program"
        GroupBox2.BackgroundImage = Nothing
        GroupBox2.BackColor = Color_Panels
        WebBrowserStop()
        PictureBox1.Visible = False
        WMP.Visible = False
        RTB.Visible = True
        Panel_EditCommands.Visible = Not FullScreen
    End Sub
    Private Sub PreparePanelsForWeb()
        GroupBox2.Text = ""
        GroupBox2.BackgroundImage = Nothing
        GroupBox2.BackColor = Color_Panels
        WMP.URL = ""
        PictureBox1.Visible = False
        WMP.Visible = False
        RTB.Visible = False
        WB.Parent = GroupBox2
        WB.Anchor = AnchorStyles.Top Or AnchorStyles.Bottom Or AnchorStyles.Left Or AnchorStyles.Right
        WB.Location = New System.Drawing.Point(0, 0)
        WB.Size = GroupBox2.Size
        WB.Show()
        Panel_EditCommands.Visible = False
    End Sub
    Private Sub WebBrowserStop()
        If WB.Visible Then
            WB.Stop()
            WB.Hide()
        End If
    End Sub

    ' =============================================================================================
    '   EXECUTION HELPING FUNCTIONS - Directly executed in the Worker-Thread
    ' =============================================================================================
    Friend Sub Beep_RepetitionLimited(ByVal ms As Int32)
        Static sw As Stopwatch
        If sw Is Nothing Then
            sw = New Stopwatch
        Else
            If sw.ElapsedMilliseconds < ms Then Return
        End If
        sw.Reset()
        sw.Start()
        Beep()
    End Sub
    Sub Wait_Seconds(ByVal seconds As Double)
        Thread.Sleep(CInt(seconds * 1000))
    End Sub

    Sub Wait_Button(ByVal ButtonName As String)
        Dim button As CheckBox = Nothing
        Select Case ButtonName.ToLower
            Case Button_1.Text.ToLower : button = Button_1
            Case Button_2.Text.ToLower : button = Button_2
            Case Button_3.Text.ToLower : button = Button_3
            Case Button_4.Text.ToLower : button = Button_4
            Case Button_5.Text.ToLower : button = Button_5
        End Select
        If button Is Nothing Then
            ButtonName = RTB.ExtractFirstWord(ButtonName)
            Select Case ButtonName.ToLower
                Case RTB.ExtractFirstWord(Button_1.Text).ToLower : button = Button_1
                Case RTB.ExtractFirstWord(Button_2.Text).ToLower : button = Button_2
                Case RTB.ExtractFirstWord(Button_3.Text).ToLower : button = Button_3
                Case RTB.ExtractFirstWord(Button_4.Text).ToLower : button = Button_4
                Case RTB.ExtractFirstWord(Button_5.Text).ToLower : button = Button_5
            End Select
        End If
        If button IsNot Nothing Then
            Do
                Threading.Thread.Sleep(5)
            Loop Until button.Checked
            UncheckButton(button)
        End If
    End Sub

    Private Function FindElseOrEndif() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line = "else" Then
                If counter <= 0 Then
                    Return i
                End If
            ElseIf line = "endif" Then
                If counter <= 0 Then
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("if") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindEndif() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTBLines.Length - 1
            line = RTBLines(i).Trim.ToLower
            If line = "endif" Then
                If counter <= 0 Then
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("if") Then
                counter += 1
            End If
        Next
        Return -1
    End Function


    ' =============================================================================================
    '  Keyboard Keys Events
    ' =============================================================================================
    Private Structure KeyEvent
        Public KeyCode As Keys
        Public IsGosub As Boolean
        Public LabelText As String
    End Structure
    Private KeyEvents(-1) As KeyEvent
    Private Sub ClearKeyEvents()
        ReDim KeyEvents(-1)
    End Sub
    Private Sub SetKeyEvent(ByVal s1 As String, ByVal s2 As String, ByVal s3 As String)
        Dim k As Keys = GetKeyCode(s1)
        Dim ix As Int32 = -1
        ' -------------------------------------------- test if KeyCode already exists
        For i As Int32 = 0 To KeyEvents.Length - 1
            If k = KeyEvents(i).KeyCode Then
                ix = i
            End If
        Next
        ' -------------------------------------------- if not exists create a new place
        If ix < 0 Then
            ix = KeyEvents.Length
            ReDim Preserve KeyEvents(ix)
        End If
        ' -------------------------------------------- add the new KeyEvent
        With KeyEvents(ix)
            .KeyCode = k
            .IsGosub = s2.ToLower = "gosub"
            .LabelText = s3.ToLower
        End With
    End Sub
    Private Function GetKeyCode(ByVal str As String) As Keys
        Select Case str.ToLower
            Case "1" : Return Keys.D1
            Case "2" : Return Keys.D2
            Case "3" : Return Keys.D3
            Case "4" : Return Keys.D4
            Case "5" : Return Keys.D5
            Case "6" : Return Keys.D6
            Case "7" : Return Keys.D7
            Case "8" : Return Keys.D8
            Case "9" : Return Keys.D9
            Case "0" : Return Keys.D0
            Case "a" : Return Keys.A
            Case "b" : Return Keys.B
            Case "c" : Return Keys.C
            Case "d" : Return Keys.D
            Case "e" : Return Keys.E
            Case "f" : Return Keys.F
            Case "g" : Return Keys.G
            Case "h" : Return Keys.H
            Case "i" : Return Keys.I
            Case "j" : Return Keys.J
            Case "k" : Return Keys.K
            Case "l" : Return Keys.L
            Case "m" : Return Keys.M
            Case "n" : Return Keys.N
            Case "o" : Return Keys.O
            Case "p" : Return Keys.P
            Case "q" : Return Keys.Q
            Case "r" : Return Keys.R
            Case "s" : Return Keys.S
            Case "t" : Return Keys.T
            Case "u" : Return Keys.U
            Case "v" : Return Keys.V
            Case "w" : Return Keys.W
            Case "x" : Return Keys.X
            Case "y" : Return Keys.Y
            Case "z" : Return Keys.Z
            Case "f1" : Return Keys.F1
            Case "f2" : Return Keys.F2
            Case "f3" : Return Keys.F3
            Case "f4" : Return Keys.F4
            Case "f5" : Return Keys.F5
            Case "f6" : Return Keys.F6
            Case "f7" : Return Keys.F7
            Case "f8" : Return Keys.F8
            Case "f9" : Return Keys.F9
            Case "f10" : Return Keys.F10
            Case "f11" : Return Keys.F11
            Case "f12" : Return Keys.F12
            Case "left" : Return Keys.Left
            Case "right" : Return Keys.Right
            Case "up" : Return Keys.Up
            Case "down" : Return Keys.Down
            Case "space" : Return Keys.Space
            Case "esc" : Return Keys.Escape
        End Select
    End Function
    Private Sub ExecKeysEvent(ByVal keycode As Keys)
        For Each k As KeyEvent In KeyEvents
            If keycode = k.KeyCode Then
                Dim line As Int32 = FindLabel(k.LabelText)
                If line >= 0 Then
                    ExecutionThread_Stop()
                    If k.IsGosub And ExistsReturn() Then
                        ReturnStack.Push(LineInExecution + 1)
                    End If
                    GotoLine = line
                    ExecutionThread_Start()
                End If
                Return
            End If
        Next
    End Sub

    ' =============================================================================================
    '  EXECUTION DELAY
    ' =============================================================================================
    Private InstructionsCounter As Int32 = 0
    Private InstructionsCounterMax As Int32
    Private ExecutionDelayMillisec As Int32
    Private Sub SetExecutionDelayParams(ByVal n As Int32)
        If n = 0 Then n = TrackBar_Speed.Value
        If n > 9 Then n = 9
        Select Case n
            Case 1 : ExecutionDelayMillisec = 1000 : InstructionsCounterMax = 0
            Case 2 : ExecutionDelayMillisec = 500 : InstructionsCounterMax = 0
            Case 3 : ExecutionDelayMillisec = 200 : InstructionsCounterMax = 0
            Case 4 : ExecutionDelayMillisec = 100 : InstructionsCounterMax = 0
            Case 5 : ExecutionDelayMillisec = 50 : InstructionsCounterMax = 0
            Case 6 : ExecutionDelayMillisec = 10 : InstructionsCounterMax = 0
            Case 7 : ExecutionDelayMillisec = 1 : InstructionsCounterMax = 0
            Case 8 : ExecutionDelayMillisec = 1 : InstructionsCounterMax = 10
            Case 9 : ExecutionDelayMillisec = 1 : InstructionsCounterMax = 100
        End Select
    End Sub
    Private Sub ShowExecutionDelayText(ByVal n As Int32)
        Dim s As String = ""
        Select Case n
            Case 1 : s = "1 instructions per second - CPU usage very low"
            Case 2 : s = "2 instructions per second - CPU usage very low"
            Case 3 : s = "5 instructions per second - CPU usage very low"
            Case 4 : s = "10 instructions per second - CPU usage very low"
            Case 5 : s = "20 instructions per second - CPU usage very low"
            Case 6 : s = "100 instructions per second - CPU usage very low"
            Case 7 : s = "1000 instructions per second - 1 mS each instruction - CPU usage very low"
            Case 8 : s = "10 000 instructions per second - 100 uS each instruction - CPU usage about 1%"
            Case 9 : s = "100 000 instructions per second - 10 uS each instruction - CPU usage about 10%"
        End Select
        StatusLabel1.Text = s
    End Sub
    Private Sub ExecutionDelay_Variable()
        InstructionsCounter += 1
        If InstructionsCounter >= InstructionsCounterMax Then
            InstructionsCounter = 0
            Thread.Sleep(ExecutionDelayMillisec)
        End If
    End Sub
    Private Sub ExecutionDelay_Minimum()
        InstructionsCounter += 1
        If InstructionsCounter >= InstructionsCounterMax Then
            InstructionsCounter = 0
            Thread.Sleep(1)
        End If
    End Sub


    ' =============================================================================================
    '  EXECUTION
    ' =============================================================================================
    Private LineInExecution As Int32 = -1
    Private RTBLines() As String
    Private GotoLine As Int32 = 1
    Private ReturnStack As Stack(Of Integer) = New Stack(Of Integer)
    Dim sw As Stopwatch = New Stopwatch ' speed tester

    Private Sub RTB_Exec()
        If RTB.Editing Then Thread.Sleep(1) : Return
        If RTBLines Is Nothing Then Thread.Sleep(1) : Return
        If RTBLines.Length = 0 Then Thread.Sleep(1) : Return
        ' --------------------------------------------------------------- for all lines
        For i As Int32 = 0 To RTBLines.Length - 1
            ' ----------------------------------------------------------- goto ?
            If GotoLine >= 0 Then
                i = GotoLine
                GotoLine = -1
                ' ------------------------------------------------------- speed tester
                'Print_Message(sw.Elapsed.Milliseconds.ToString)
                'sw.Reset()
                'sw.Start()
            End If
            ' ----------------------------------------------------------- Tokenize to array of keywords
            Dim l() As String = RTB.Tokenize(RTBLines(i).Trim)
            ' ----------------------------------------------------------- empty line ?
            If l.Length = 0 Then ExecutionDelay_Minimum() : Continue For
            ' ----------------------------------------------------------- line in execution
            LineInExecution = i
            ' ----------------------------------------------------------- exec line
            Select Case l.Length
                Case 1
                    Select Case l(0).ToLower
                        Case "beep"
                            Beep_RepetitionLimited(100)
                        Case "else"
                            Dim n As Int32 = FindEndif()
                            If n >= 0 And n < RTBLines.Length Then
                                GotoLine = n
                                ExecutionDelay_Variable()
                                Continue For
                            End If
                        Case "return"
                            If ReturnStack.Count > 0 Then
                                Dim n As Int32 = ReturnStack.Pop
                                If n >= 0 And n < RTBLines.Length Then
                                    GotoLine = n
                                    ExecutionDelay_Variable()
                                    Continue For
                                End If
                            End If
                        Case "stop"
                            Do : Thread.Sleep(100) : Loop
                    End Select
                Case 2
                    Select Case l(0).ToLower
                        Case "gosub"
                            Dim n As Int32 = FindLabel(l(1))
                            If n >= 0 And n < RTBLines.Length Then
                                ReturnStack.Push(i + 1)
                                GotoLine = n
                                ExecutionDelay_Variable()
                                Continue For
                            End If
                        Case "goto"
                            Dim n As Int32 = FindLabel(l(1))
                            If n >= 0 And n < RTBLines.Length Then
                                GotoLine = n
                                ExecutionDelay_Variable()
                                Continue For
                            End If
                        Case "if"
                            If Not EvalBoolean(l(1)) Then
                                Dim n As Int32 = FindElseOrEndif()
                                If n >= 0 And n < RTBLines.Length Then
                                    GotoLine = n + 1
                                    ExecutionDelay_Variable()
                                    Continue For
                                End If
                            End If
                        Case "load"
                            Load_Media(l(1))
                        Case "print"
                            Print_Message(EvalString(l(1)))
                        Case "speed"
                            SetNewSpeed(EvalDouble(l(1)))
                        Case "wait"
                            Do
                                Thread.Sleep(10)
                            Loop Until EvalBoolean(l(1))
                    End Select
                Case 3
                    Select Case l(0).ToLower
                        Case "button"
                            SetButton(Val_Int(l(1)), l(2))
                        Case "wait"
                            'If l(1).ToLower = "seconds" Then Wait_Seconds(Val_Double(l(2)))
                            If l(1).ToLower = "seconds" Then Wait_Seconds(EvalDouble(l(2)))
                            If l(1).ToLower = "button" Then Wait_Button(l(2))
                        Case "v1", "v2", "v3", "v4", "v5", "v6", "v7", "v8", "v9"
                            If l(1) = "=" Then
                                Var(RTB.VarNameToIndex(l(0))) = EvalDouble(l(2))
                            End If
                        Case "s1", "s2", "s3", "s4", "s5", "s6", "s7", "s8", "s9"
                            If l(1) = "=" Then
                                StrVar(RTB.VarNameToIndex(l(0))) = EvalString(l(2))
                            End If
                    End Select
                Case 4
                    Select Case l(0).ToLower
                        Case "button"
                            If l(2).ToLower = "slot" Then SetButtonSlot(Val_Int(l(1)), Val_Int(l(3)))
                            If l(2).ToLower = "text" Then SetButton(Val_Int(l(1)), l(3))
                        Case "key"
                            If RTB.IsValidKey(l(1).ToLower) Then
                                SetKeyEvent(l(1), l(2), l(3))
                            End If
                        Case "slot"
                            Select Case l(3)
                                Case "Reset"
                                    Slots.WriteSlot(CInt(EvalDouble(l(1))), NAN_Reset)
                                Case "Sleep"
                                    Slots.WriteSlot(CInt(EvalDouble(l(1))), NAN_Sleep)
                                Case Else
                                    Slots.WriteSlot(CInt(EvalDouble(l(1))), CSng(EvalDouble(l(3))))
                            End Select
                    End Select
            End Select
            ExecutionDelay_Variable()
        Next
    End Sub

End Class